const englishFormat = (item, properties) => {
  properties.format.activeFieldId = item.id;
  properties.format.formatDatatype = "numeric";
  properties.format.formatFields.push({
    id: item.id,
    values: {
      apply: ["pane", "axis", "tooltip", "label", "actions"],
      decimalPlace: 2,
      displayUnits: "None",
      field: item.id,
      formatDatatype: "numeric",
      isApplyClicked: true,
      numberCustom: "",
      percentage: "",
      prefix: "$",
      suffix: "",
      showAllFormatFields: false,
      thousandSperator: true,
    },
  });
};

const spanishFormat = (item, properties) => {
  properties.format.activeFieldId = item.id;
  properties.format.formatDatatype = "numeric";
  properties.format.formatFields.push({
    id: item.id,
    values: {
      apply: ["pane", "axis", "tooltip", "label", "actions"],
      decimalPlace: 2,
      displayUnits: "None",
      field: item.id,
      formatDatatype: "numeric",
      isApplyClicked: true,
      numberCustom: "",
      percentage: "",
      prefix: "€ ",
      suffix: "",
      showAllFormatFields: false,
      thousandSperator: true,
    },
  });
};

const frenchFormat = (item, properties) => {
  properties.format.activeFieldId = item.id;
  properties.format.formatDatatype = "numeric";
  properties.format.formatFields.push({
    id: item.id,
    values: {
      apply: ["pane", "axis", "tooltip", "label", "actions"],
      decimalPlace: 2,
      displayUnits: "None",
      field: item.id,
      formatDatatype: "numeric",
      isApplyClicked: true,
      numberCustom: "",
      percentage: "",
      prefix: "€ ",
      suffix: "",
      showAllFormatFields: false,
      thousandSperator: true,
    },
  });
};

const changePropsForNumeric = (properties, fields) => {
  let [prefLang, prefTimeZone] = getParams();
  fields.forEach((item) => {
    if (item.type.dataType === "numeric") {
      if (prefLang === "fr") {
        frenchFormat(item, properties);
      } else if (prefLang === "es") {
        spanishFormat(item, properties);
      } else {
        englishFormat(item, properties);
      }
    }
  });
};

const changePropsForDate = (formData) => {
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang === "en-US") {
    formData.columns[0].databaseFunction.parameters.format = '"%m/%d/%Y"';
  } else if (prefLang === "fr") {
    formData.columns[0].databaseFunction.parameters.format = '"%d/%m/%Y"';
  } else if (prefLang === "es") {
    formData.columns[0].databaseFunction.parameters.format = '"%Y/%m/%d"';
  }
};

const changePropsForDateTimeZone = (formData) => {
  let [prefLang, prefTimeZone] = getParams();
  if (prefTimeZone === "EST") {
    formData.columns[0].databaseFunction.parameters.to = "'EST'";
  } else if (prefTimeZone === "NZ") {
    formData.columns[0].databaseFunction.parameters.to = "'NZ'";
  } else if (prefTimeZone === "MET") {
    formData.columns[0].databaseFunction.parameters.to = "'MET'";
  }
};
