const elementChecker = async (elementIdentifier) => {
  const checkInterval = 500; // Check every 500 milliseconds
  const maxAttempts = 10; // Try for a maximum of 10 seconds (20 * 500ms)

  let attempts = 0;

  while (attempts < maxAttempts) {
    const el = document.querySelector(elementIdentifier);
    if (el !== null) {
      return el;
    }
    await new Promise((resolve) => setTimeout(resolve, checkInterval));
    attempts++;
  }

  return null;
};

// const addingDropDown = async () => {
//   let currentURL = window.location.href;
//   let langVal = document.getElementById("languageSelector");
//   if (langVal === null) {
//     let ulEl;
//     if (currentURL.startsWith(`${baseURL}/#/report-viewer`)) {
//       ulEl = await elementChecker(
//         ".ant-layout-header.header .ant-row.ant-row-middle :nth-child(3) .ant-row.ant-row-end"
//       );
//       console.log(ulEl, "this is inside");
//     } else {
//       ulEl = await elementChecker(
//         ".ant-list.ant-list-split.user-actions .ant-list-items"
//       );
//     }

//     const selectElement = document.createElement("select");
//     selectElement.id = "languageSelector";
//     selectElement.style.backgroundColor = "transparent";
//     selectElement.style.border = "none";

//     const option1 = document.createElement("option");
//     option1.text = "English";
//     option1.value = "en-US";

//     const option2 = document.createElement("option");
//     option2.text = "French";
//     option2.value = "fr";

//     const option3 = document.createElement("option");
//     option3.text = "Spanish";
//     option3.value = "es";

//     selectElement.appendChild(option1);
//     selectElement.appendChild(option2);
//     selectElement.appendChild(option3);

//     const optionElements = selectElement.querySelectorAll("option");
//     optionElements.forEach((option) => {
//       option.style.backgroundColor = "white";
//       option.style.color = "black";

//       // Add a hover effect to options
//       option.addEventListener("mouseover", () => {
//         option.style.color = "blue";
//       });

//       // Reset styles on mouseout
//       option.addEventListener("mouseout", () => {
//         option.style.backgroundColor = "skyblue";
//         option.style.color = "darkblue";
//       });
//     });

//     let liEl = document.createElement("li");
//     liEl.appendChild(selectElement);
//     ulEl.appendChild(liEl);
//     let localeParam = getParams();
//     selectElement.value = localeParam === null ? "en-US" : localeParam;
//     selectElement.addEventListener("change", () => {
//       document.localeParam = `prefLang=${selectElement.value}`;
//       pathChecker();
//     });
//     if (currentURL.startsWith(`${baseURL}/#/report-viewer`)) {
//       selectElement.addEventListener("change", () => {
//         document.localeParam = `prefLang=${selectElement.value}`;
//         location.reload();
//       });
//     }
//   }
// };

// const addingDropDownInNewPage = async () => {
//   console.log("targtedRow");
// };

const addingParamsToUrl = () => {
  let newURL = window.location.href;
  let newParam = "locale=en-US&timezone=IST";

  if (newURL.includes("?")) {
    newURL += "&" + newParam;
  } else {
    newURL += "?" + newParam;
  }

  history.pushState(null, null, newURL);

  console.log(newURL);
  return newURL;
};

const getParams = () => {
  const hash = window.location.hash;
  const parts = hash.split("?");

  if (parts.length > 1) {
    const query = parts[1];
    const params = new URLSearchParams(query);
    const localeValue = params.get("locale");
    const timezoneValue = params.get("timezone");
    return [localeValue, timezoneValue];
  } else {
    console.log("No query parameters in the fragment identifier.");
  }
};

const homeMainFunction = async () => {
  const checkInterval = 500;
  const maxAttempts = 10;
  let attempts = 0;
  while (attempts < maxAttempts) {
    let ulEl = document.querySelector(
      ".hi-disk-space .ant-card-head-title div"
    );
    if (ulEl !== null) {
      let [prefLang, prefTimeZone] = getParams();
      console.log(prefLang, "slkfjdslkj");
      if (prefLang.startsWith("fr")) {
        changingHomeUI("french");
      } else if (prefLang.startsWith("es")) {
        changingHomeUI("spanish");
      } else {
        changingHomeUI("english");
      }
      break;
    }
    await new Promise((resolve) => setTimeout(resolve, checkInterval));
    attempts++;
  }
};

const homeRecycleBinMainFunction = async () => {
  console.log("hello recyclle bint");
  let el = await elementChecker("div.recycle-bin-title > span");
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingHomeRecycleBinUI("french");
  } else if (prefLang.startsWith("es")) {
    changingHomeRecycleBinUI("spanish");
  } else {
    changingHomeRecycleBinUI("english");
  }
};
const homeManagementMainFunction = async () => {
  let el = await elementChecker(".middleware-routes-data-container");
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingHomeManagementMainFunctionUI("french");
  } else if (prefLang.startsWith("es")) {
    changingHomeManagementMainFunctionUI("spanish");
  } else {
    changingHomeManagementMainFunctionUI("english");
  }
};

const homeExtraPathsFunction = (async = () => {
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingHomeExtraPathsFunctionUI("french");
  } else if (prefLang.startsWith("es")) {
    changingHomeExtraPathsFunctionUI("spanish");
  } else {
    changingHomeExtraPathsFunctionUI("english");
  }
});

const homeUserManagementOrgMainFunction = async () => {
  let el = await elementChecker(
    ".hi-user-management-box .hi-ellipses span.ant-typography.hi-title"
  );
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingHomeUserManagementOrgUI("french");
  } else if (prefLang.startsWith("es")) {
    changingHomeUserManagementOrgUI("spanish");
  } else {
    changingHomeUserManagementOrgUI("english");
  }
};

const metadataMainFunction = async () => {
  let el = await elementChecker(
    "section.edit-section .connections-container-1 span.ant-divider-inner-text"
  );
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingMetadataUI("french");
  } else if (prefLang.startsWith("es")) {
    changingMetadataUI("spanish");
  } else {
    changingMetadataUI("english");
  }
};

const reportMainFunction = async () => {
  await elementChecker(
    'div.hr-editing-area ul.hr-editing-area-items [data-testid ="tool-1" ]'
  );
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingReportUI("french");
  } else if (prefLang.startsWith("es")) {
    changingReportUI("spanish");
  } else {
    changingReportUI("english");
  }
};

const dashboardMainFunction = async () => {
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingDashboardUI("french");
  } else if (prefLang.startsWith("es")) {
    changingDashboardUI("spanish");
  } else {
    changingDashboardUI("english");
  }
};

const dataSourceMainFunction = () => {
  let [prefLang, prefTimeZone] = getParams();
  if (prefLang.startsWith("fr")) {
    changingDataSourceUI("french");
  } else if (prefLang.startsWith("es")) {
    changingDataSourceUI("spanish");
  } else {
    changingDataSourceUI("english");
  }
};

const loadJSONFile = (filePath, callback) => {
  const xhr = new XMLHttpRequest();
  xhr.overrideMimeType("application/json");
  xhr.open("GET", filePath, true);
  xhr.onreadystatechange = function () {
    if (xhr.readyState === 4 && xhr.status === 200) {
      try {
        const data = JSON.parse(xhr.responseText);
        callback(data);
      } catch (error) {
        console.error("Error parsing JSON:", error);
      }
    }
  };
  xhr.send(null);
};

const changingHomeUI = async (locale) => {
  loadJSONFile(
    `${baseURL}/js/jspatches/langs/${locale}.json`,
    function (translation) {
      changingHomeAdminTabs(translation);
      changingHomeCardsTitle(translation);
      changingHomeCardsSubtitles(translation);
      changingHomeLicenseCard(translation);
      changingHomeErrorCard(translation);
      changingSidebarUI(translation);
    }
  );
};

const changingMetadataUI = (locale) => {
  loadJSONFile(
    `${baseURL}/js/jspatches/langs/${locale}.json`,
    function (translation) {
      changingMetadataSideBar(translation);
      changingMetadataEditBar(translation);
    }
  );
};

const changingReportUI = (locale) => {
  loadJSONFile(
    `${baseURL}/js/jspatches/langs/${locale}.json`,
    function (translation) {
      changingFieldDropArea(translation);
      changingReportEditingArea(translation);
      changingReportMetadataEditingArea(translation);
    }
  );
};

const changingDataSourceUI = (locale) => {
  loadJSONFile(
    `${baseURL}/js/jspatches/langs/${locale}.json`,
    function (translation) {
      changingDataSourceHeaderTab(translation);
      changingDataSourceCards(translation);
      changingSidebarUI(translation);
    }
  );
};

const changingDashboardUI = async (locale) => {
  await elementChecker(
    '[data-testid = "hi-designer-parameters-button"] .hi-shortcut-container'
  );
  loadJSONFile(`${baseURL}/js/jspatches/langs/${locale}.json`, function (t) {
    let filterBtn = document.querySelector(
      '[data-testid = "hi-designer-parameters-button"] .hi-shortcut-container'
    );
    filterBtn.textContent = t["Filters"];
    let reportBtnEl = document.querySelector(
      '[data-testid = "hi-designer-tools-shelf"] > .handle-bar > .ant-card > .ant-card-body .ant-card-grid:last-child > div > div'
    );
    reportBtnEl.textContent = t["Reports"];
  });
};

const changingHomeCardsTitle = (t) => {
  let diskSpaceTitleEl = document.querySelector(
    ".hi-disk-space .ant-card-head-title div"
  );
  diskSpaceTitleEl.textContent = t["Disk Space"];
  let jvmTitleEl = document.querySelector(
    ".hi-jvm-memory .ant-card-head-title div"
  );
  jvmTitleEl.textContent = t["JVM Memory"];
  let tempDirectoryEl = document.querySelector(
    ".hi-temp-directory .ant-card-head-title div"
  );
  tempDirectoryEl.textContent = t["Temp Directory"];

  let cardCacheTitleEl = document.querySelector(
    ".hi-overview-cache-box .hi-cache-card .hi-overview-main-heading span"
  );
  cardCacheTitleEl.textContent = t["Cache"];
};

const changingHomeAdminTabs = (t) => {
  let ulEl = document.querySelectorAll(
    ".hi-admin-tabs-container .hi-tabs-menu .ant-menu-item"
  );
  const vals = [
    "Overview",
    "Recycle Bin",
    "User Management",
    "System Details",
    "Management",
    "Schedule",
    "Plugins",
  ];
  let index = 0;
  ulEl.forEach((liEl) => {
    let liVal = liEl.querySelector(".hi-tutorial-info");
    liVal.textContent = t[vals[index]];
    index++;
  });
};

const changingHomeLicenseCard = (t) => {
  let licenseTitle = document.querySelector(".hi-license .ant-card-head-title");
  licenseTitle.textContent = t["License Details"];
  let licenseContentUl = document.querySelectorAll(
    ".hi-license .ant-card-body article .ant-row div"
  );
  let vals = ["Helical Insight", "Build", "License Type", "Expiration Date"];
  let index = 0;
  for (let li of licenseContentUl) {
    let liElText = li.querySelector("span.ant-typography-ellipsis");
    if (liElText != null) {
      let textVal = liElText.textContent.split(":").pop();
      liElText.textContent = `${t[vals[index]]} : ${textVal}`;
      index++;
    }
  }
};

const changingSidebarUI = (t) => {
  let sidebarEl = document.querySelectorAll(
    ".hi-sidebar-grid > div:first-child .hi-sidebar-content > div.ant-collapse > div"
  );
  let vals = ["Discover", "Statistics", "What's New"];
  let index = 0;
  sidebarEl.forEach((item) => {
    let text = item.querySelector("span.ant-collapse-header-text");
    text.textContent = t[vals[index]];
    index++;
  });
  let browserBtn = document.querySelector(
    ".hi-sidebar-file-browser-button span:last-child"
  );
  browserBtn.textContent = t["File Browser"];

  let searchPlaceHolderEl = document.querySelector(
    "[data-testid = 'hi-sidebar-footer-search']"
  );
  searchPlaceHolderEl.placeholder = t["Search inside file browser"];
};

const changingHomeCardsSubtitles = (t) => {
  let diskSpaceSubTitleEl = document.querySelector(
    ".hi-disk-space .hi-overview-main-heading"
  );
  diskSpaceSubTitleEl.textContent = t["Total disk space"];
  let jvmSubTitleEl = document.querySelector(
    ".hi-jvm-memory .hi-overview-main-heading"
  );
  jvmSubTitleEl.textContent = t["Total JVM memory"];
  let tempDirectorySubTitleEl = document.querySelector(
    ".hi-temp-directory .hi-overview-main-heading"
  );
  tempDirectorySubTitleEl.textContent = t["Total temporary file(s)"];

  let cacheResourceSubTitleEl = document.querySelector(
    ".hi-overview-cache-box .hi-cache-card p.hi-overview-main-heading"
  );
  cacheResourceSubTitleEl.textContent = t["Resources in memory"];
  let cachedReportSubTitleEl = document.querySelector(
    ".hi-overview-cache-box .hi-cached-reports p.hi-overview-main-heading"
  );
  cachedReportSubTitleEl.textContent = t["Cached reports"];
  let cachedDataSourceSubTitleEl = document.querySelector(
    ".hi-overview-cache-box .hi-data-sources p.hi-overview-main-heading"
  );
  cachedDataSourceSubTitleEl.textContent = t["Data sources cached"];
};

const changingHomeErrorCard = (t) => {
  let loggerCardTitle = document.querySelector(
    ".hi-overview-box .hi-logger .ant-card-head-title"
  );
  loggerCardTitle.textContent = t["Logger settings"];
  let reloadCardTitle = document.querySelector(
    ".hi-overview-box .hi-reload-configs .ant-card-head-title"
  );
  reloadCardTitle.textContent = t["Reload Configurations"];

  let vals = ["Application", "Validation", "Cache"];
  let btnCont = document.querySelectorAll(
    ".hi-overview-box .hi-reload-configs .ant-row-center div"
  );
  index = 0;
  btnCont.forEach((btn) => {
    let textEl = btn.querySelector("span.ant-typography");
    textEl.textContent = t[vals[index]];
    index++;
  });
};

const changingMetadataSideBar = (t) => {
  let sidebarEl = document.querySelectorAll(
    ".hi-metadata-sidebar-content > .ant-row"
  );
  let index = 0;
  sidebarEl.forEach((eachElement) => {
    if (index === 0) {
      let createEl = eachElement.querySelector("div.ant-col:first-child span");
      createEl.textContent = t["CREATE"];

      let editEl = eachElement.querySelector(
        "div.ant-col:last-child > .hi-tutorial-info span"
      );
      editEl.textContent = t["EDIT"];
    } else {
    }
    index++;
  });

  let footerEl = document.querySelector(
    ".metadata-sidebar-footer-section span.ant-typography strong"
  );
  let noTableElement = document.querySelector(
    ".no-tables-text-metadata-section strong"
  );
  noTableElement.textContent = t["Metadata Empty text"];
  let reqText = footerEl.textContent.split(" ");
};

const changingMetadataEditBar = (t) => {
  let firstTitle = document.querySelector(
    "section.edit-section .connections-container-1 span.ant-divider-inner-text"
  );
  firstTitle.textContent = t["Current DataSource(s)"];

  let sideEditBarUl = document.querySelectorAll(
    "aside.metadata-editor-sider ul.ant-menu li"
  );
  let index = 0;
  let keys = ["Info", "Joins", "", "Views", "Security"];
  sideEditBarUl.forEach((li) => {
    let reqText = li.querySelector("div.hi-metadata-sider-menu-title");
    if (index !== 2) {
      reqText.textContent = t[keys[index]];
    }

    index++;
  });
};

const changingFieldDropArea = (t) => {
  let columnTitleEl = document.querySelector(
    "div.space-align-container .hi-fields-list:first-child .field-heading-label span.ant-typography"
  );
  columnTitleEl.textContent = t["Columns"];
  let rowTitleEl = document.querySelector(
    "div.space-align-container .hi-fields-list:last-child .field-heading-label span.ant-typography"
  );
  rowTitleEl.textContent = t["Rows"];

  let colEmptyText = document.querySelector(
    ".field-drop-area div#spaceElem-column span.default-text"
  );
  colEmptyText.textContent =
    t["Add Column or Double click this area to add Custom Column"];
  let rowEmptyText = document.querySelector(
    ".field-drop-area div#spaceElem-row span.default-text"
  );
  rowEmptyText.textContent =
    t["Add row or Double click this area to add Custom Column"];
};

const changingReportEditingArea = (t) => {
  // let allReportOptions = document.querySelectorAll(
  //   ".hr-editing-area .hr-editing-area-items > li"
  // );
  // let index = 0;
  // let allTitles = [
  //   "helloworld1",
  //   "helloworld2",
  //   "helloworld3",
  //   "helloworld4",
  //   "helloworld5",
  //   "helloworld6",
  //   "helloworld7",
  //   "",
  // ];

  // allReportOptions.forEach((eachItem) => {
  //   if (index !== 7) {
  //     let title = eachItem.querySelector(".ant-menu-title-content span > span");
  //     title.textContent = allTitles[index];
  //   }
  //   index++;
  // });

  let visOptions = document.querySelectorAll(".hr-viz-list div.ant-row >  div");
  let visNames = ["Table", "CrossTab", "Grid Chart", "More Charts", "Maps"];
  index = 0;
  visOptions.forEach((item) => {
    let visNameEl = item.querySelector(
      ".hi-shortcut-container span.ant-typography"
    );
    visNameEl.textContent = t[visNames[index]];
    index++;
  });
  let visSearchEl = document.querySelector(
    ".hr-viz-list-area input.ant-input "
  );
  visSearchEl.placeholder = `${t["Search"]}...`;
};

const changingReportMetadataEditingArea = (t) => {
  let metadataSearchEl = document.querySelector(
    ".hr-metadata-container .hr-md-search"
  );
  metadataSearchEl.placeholder = t["Search tables of columns"];

  let hrMetadataEmptyText = document.querySelector(
    ".ant-table-placeholder .ant-table-cell .ant-empty .ant-empty-description"
  );
  hrMetadataEmptyText.textContent = t["No Data"];

  let fileBrowserBtnEl = document.querySelector(
    ".hi-sidebar-file-browser-button"
  );
  fileBrowserBtnEl.textContent = t["File Browser"];

  const fileBrowserSearchEl = document.querySelector(
    '[data-testid="hi-sidebar-footer-search"]'
  );
  fileBrowserSearchEl.placeholder = t["Search inside file browser"];
};

const changingDataSourceHeaderTab = (t) => {
  let headerTitle = document.querySelector(
    ".datasource-header div.hi-tutorial-info"
  );
  headerTitle.textContent = t["Choose Database"];
  let dataSourceMenuUlEl = document.querySelectorAll(
    ".datasource-header ul.datasource-menu li"
  );
  vals = [
    "All",
    "Supported",
    "Bigdata",
    "Flatfiles",
    "RDBMS",
    "NoSQL & Big Data",
    "Advance",
  ];
  index = 0;
  dataSourceMenuUlEl.forEach((li) => {
    if (index !== 7) {
      let liEl = li.querySelector("a");
      liEl.textContent = t[vals[index]];
      index++;
    }
  });

  let inputEl = document.querySelector(".datasource-header input.ant-input");
  inputEl.placeholder = t["search database"];
};

const changingDataSourceCards = async (t) => {
  const checkInterval = 500;
  const maxAttempts = 20;
  let attempts = 0;

  while (attempts < maxAttempts) {
    let cardsCont = document.querySelectorAll(
      ".datasource-card .ant-card-body div"
    );
    if (cardsCont.length > 0) {
      cardsCont.forEach((card) => {
        let title = card.querySelector(".title");
        title.textContent = t[title.getAttribute("data-testid")];
      });
    }
    await new Promise((resolve) => setTimeout(resolve, checkInterval));
    attempts++;
  }
};

const changingHomeRecycleBinUI = (locale) => {
  loadJSONFile(`${baseURL}/js/jspatches/langs/${locale}.json`, function (t) {
    changingHomeAdminTabs(t);
    changingSidebarUI(t);
    let recycleBinTitleEl = document.querySelector(
      "div.recycle-bin-title > span"
    );
    recycleBinTitleEl.textContent = t["Recycle Bin"];

    let topUlEl = document.querySelectorAll(
      ".recycle-bin-header-data-container .ant-card.ant-card-bordered.ant-card-hoverable.actions-card .ant-row-middle div"
    );
    let keys = [
      "Refresh",
      "Restore Selected",
      "Delete Selected",
      "Empty Recycle Bin",
    ];
    let index = 0;
    topUlEl.forEach((li) => {
      let reqText = li.querySelector("button span:last-child");
      reqText.textContent = t[keys[index]];
      reqText.style.width = "120px";
      reqText.style.overflow = "hidden";
      index++;
    });

    let tableHeaderEl = document.querySelectorAll(
      ".recycle-bin-table-container thead.ant-table-thead th"
    );
    let tableKeys = [
      "",
      "",
      "Resource",
      "Deleted On",
      "Deleted By",
      "Type",
      "Actions",
      "Details",
      "",
    ];
    let tableIndex = 0;
    tableHeaderEl.forEach((item) => {
      if ([2, 4, 5].includes(tableIndex)) {
        let text = item.querySelector(
          ".ant-table-column-title span.ant-table-column-title"
        );
        text.textContent = t[tableKeys[tableIndex]];
      } else if ([6, 7].includes(tableIndex)) {
        item.textContent = t[tableKeys[tableIndex]];
      } else if (tableIndex === 3) {
        let text = item.querySelector(".ant-table-column-title");
        text.textContent = t[tableKeys[tableIndex]];
      }
      tableIndex++;
    });
  });
};
const changingHomeUserManagementOrgUI = (locale) => {
  loadJSONFile(`${baseURL}/js/jspatches/langs/${locale}.json`, function (t) {
    changingHomeAdminTabs(t);
    changingSidebarUI(t);
    let orgTitle = document.querySelector(
      ".hi-user-management-box .hi-ellipses span.ant-typography.hi-title"
    );
    orgTitle.textContent = t["Organizations"];

    let usersTitle = document.querySelector(
      ".hi-user-management-box .hi-user-card .hi-ellipses span.ant-typography.hi-title"
    );
    usersTitle.textContent = t["Users"];
    let btns = document.querySelectorAll(
      ".hi-user-management-box .hi-card-body div.ant-card-body div.ant-row > div"
    );
    let btnKeys = ["Add User", "Add Organization", "Add Role"];
    let btnIndex = 0;

    btns.forEach((btn) => {
      let text = btn.querySelector("button > span");
      text.textContent = t[btnKeys[btnIndex]];

      btnIndex++;
    });

    let tableEl = document.querySelectorAll(".ant-table-thead th");
    let tableKeys = ["", "Organization Name", "Description", "Actions"];
    let tableIndex = 0;
    tableEl.forEach((item) => {
      if (tableIndex === 2) {
        let reqText = item.querySelector(".ant-table-column-title span ");
        reqText.textContent;
      } else if (tableIndex === 1) {
        let reqText = item.querySelector(".ant-table-column-title span ");
      } else if (tableIndex === 3) {
        let reqText = item.querySelector("span");
        reqText = t[tableKeys[tableIndex]];
      }
      tableIndex++;
    });
  });
};

const changingHomeExtraPathsFunctionUI = (locale) => {
  loadJSONFile(
    `${baseURL}/js/jspatches/langs/${locale}.json`,
    function (translation) {
      changingHomeAdminTabs(translation);
      changingSidebarUI(translation);
    }
  );
};

const changingHomeManagementMainFunctionUI = (locale) => {
  loadJSONFile(`${baseURL}/js/jspatches/langs/${locale}.json`, function (t) {
    changingHomeAdminTabs(t);
    changingSidebarUI(t);
    let blueTextEl = document.querySelector(
      "div.middleware-routes-data-container > div"
    );
    blueTextEl.textContent = t["BlueAlertText"];
    let index = 0;
    let keys = ["Middleware", "DICE", "DICE Storage", "Import", ""];

    let ulEl = document.querySelectorAll("ul.management-menu li");
    ulEl.forEach((item) => {
      console.log(item);
      if (index !== 4) {
        let reqText = item.querySelector("span");
        reqText.textContent = t[keys[index]];
      }
      index++;
    });
  });
};

const pathChecker = async () => {
  let currentURL = window.location.href;
  let dataSourcePaths = [
    `${baseURL}/#/datasource/all`,
    `${baseURL}/#/datasource/supported`,
    `${baseURL}/#/datasource/bigdata`,
    `${baseURL}/#/datasource/flatfiles`,
    `${baseURL}/#/datasource/rdbms`,
    `${baseURL}/#/datasource/nosql`,
    `${baseURL}/#/datasource/nosql`,
  ];

  if (currentURL.startsWith(`${baseURL}/#/admin/overview`)) {
    // addingParamsToUrl();
    homeMainFunction();
  } else if (dataSourcePaths.includes(currentURL)) {
    dataSourceMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/metadata`)) {
    metadataMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/helical-report`)) {
    reportMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/dashboard-designer`)) {
    dashboardMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/admin/recycle-bin`)) {
    homeRecycleBinMainFunction();
  } else if (
    currentURL.startsWith(`${baseURL}/#/admin/usermanagement/organizations`)
  ) {
    homeUserManagementOrgMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/admin/usermanagement/roles`)) {
    homeUserManagementRoleMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/admin/usermanagement/users`)) {
    homeUserManagementUserMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/admin/management`)) {
    homeManagementMainFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/admin/Schedule`)) {
    homeExtraPathsFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/admin/plugins`)) {
    homeExtraPathsFunction();
  } else if (currentURL.startsWith(`${baseURL}/#/report-viewer`)) {
    // setTimeout(addingDropDownInNewPage, 5000);
  }
};

window.addEventListener("hashchange", async function () {
  // await addingDropDown();
  pathChecker();
});

const onStart = async () => {
  // await addingDropDown();
  pathChecker();
};

onStart();
